/* This file was generated by scramble.py. */
#line 1 "src/levels.py"
#include "levels.h"
#line 11
Level level;
#line 13
void squared_forest(int xr, int yr, int trees, int good) {
    for (int i = 0; i < trees; i += 1) {
        str kinds [] = {"oak", "fir", "eucalypt"};
        int rk = 2;
        if (i < good) {
            rk = land_rand(0, 1);
        }
#line 19
        str kind = kinds [rk];
        for (int r = 0; r < 100; r += 1) {
            float x = land_rnd(- xr, xr);
            float y = land_rnd(- yr, yr);
#line 24
            Tree * tree = place_tree(x, y, kind);
            if (tree) {
#line 25
                break;
            }
        }
    }
}
#line 27
void round_forest(int radius, int trees, int good) {
    for (int i = 0; i < trees; i += 1) {
        str kinds [] = {"oak", "fir", "eucalypt"};
        int rk = 2;
        if (i < good) {
            rk = land_rand(0, 1);
        }
#line 33
        str kind = kinds [rk];
        for (int r = 0; r < 100; r += 1) {
            float a = land_rnd(- pi, pi);
            float d = land_rnd(0, radius);
            float x = d * cos(a);
            float y = d * sin(a);
            Tree * tree = place_tree(x, y, kind);
            if (tree) {
#line 40
                break;
            }
        }
    }
}
#line 42
void tools(int water, int wind, int fire, int oaks, int firs) {
    level.tools [0] = water;
    level.tools [1] = wind;
    level.tools [2] = fire;
    level.tools [3] = oaks;
    level.tools [4] = firs;
}
Level* levels_start(int number) {
    level.number = number;
    level.tick = 0;
    level.done = 0;
#line 54
    level.name = "the end";
    tools(- 1, - 1, - 1, - 1, - 1);
#line 57
    if (number == 1) {
        squared_forest(100, 100, 20, 20);
        level.required = 15;
        tools(150, 0, 0, 0, 0);
        level.name = "Use your Bog-Douser™!";
    }
    if (number == 2) {
        squared_forest(400, 50, 30, 30);
        level.required = 15;
        tools(100, 0, 0, 0, 0);
        level.name = "Douse the forest fires!";
    }
    if (number == 3) {
        squared_forest(150, 150, 30, 30);
        level.required = 20;
        tools(50, 100, 0, 0, 0);
        level.name = "Beetles again! Use the Tree-Tosser™!";
    }
    if (number == 4) {
        round_forest(200, 40, 40);
        level.required = 30;
        tools(200, 200, 0, 0, 0);
        level.name = "Protect the forest!";
    }
    if (number == 5) {
        round_forest(400, 31, 30);
        level.required = 10;
        tools(0, 0, 100, 0, 0);
        level.name = "Invasive species! Use the Flame-Thrower™!";
    }
    if (number == 6) {
        round_forest(70, 10, 10);
        level.required = 10;
        tools(0, 0, 200, 0, 0);
        level.name = "Kill them with fire!";
    }
    if (number == 7) {
        round_forest(400, 50, 45);
        level.required = 30;
        tools(100, 100, 100, 0, 0);
        level.name = "Pest control...";
    }
    if (number == 8) {
        level.required = 20;
        tools(0, 0, 200, 100, 0);
        level.name = "Reforestation";
    }
    if (number == 9) {
        level.required = 20;
        tools(0, 0, 900, 0, 100);
        level.name = "Reforestation part 2";
    }
    if (number == 10) {
        level.required = 60;
        round_forest(400, 100, 95);
        tools(999, 999, 999, 50, 50);
        level.name = "Plagued!";
    }
    if (number == 11) {
        level.required = 30;
        round_forest(400, 100, 50);
        tools(999, 999, 999, 50, 50);
        level.name = "Overgrown!";
    }
    if (number == 12) {
        level.required = 30;
        round_forest(400, 100, 95);
        tools(999, 999, 999, 10, 10);
        level.name = "The final test";
    }
    return & level;
}
void beetles(int n, int radius) {
    for (int i = 0; i < n; i += 1) {
        float a = land_rnd(0, 2 * pi);
        float x = radius * cos(a);
        float y = radius * sin(a);
        place_tree(x, y, "beetle");
    }
}
#line 136
void fires(int n, int radius) {
    for (int i = 0; i < n; i += 1) {
        float a = land_rnd(0, 2 * pi);
        float x = radius * cos(a);
        float y = radius * sin(a);
        place_tree(x, y, "fir");
        trees_callback(game->trees, x, y, 30, tree_burn);
    }
}
#line 144
void levels_tick(void) {
    level.tick++;
    if (level.number == 1) {
        for (int wave = 0; wave < 10; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                if (wave < 4) {
#line 149
                    beetles(1, 400);
                }
#line 150
                else if (wave < 8) {
#line 150
                    beetles(2, 400);
                }
#line 151
                else if (wave < 9) {
#line 151
                    beetles(3, 400);
                }
#line 151
                else {
#line 153
                    beetles(4, 400);
                    level.done = 1;
                }
            }
        }
    }
#line 156
    if (level.number == 2) {
        for (int wave = 0; wave < 3; wave += 1) {
            if (level.tick == 180 + 240 * wave) {
                if (wave == 2) {
                    level.done = 1;
                }
#line 161
                place_tree(- 400, 0, "fir");
                trees_callback(game->trees, - 400, 0, 30, tree_burn);
                place_tree(400, 0, "fir");
                trees_callback(game->trees, 400, 0, 30, tree_burn);
#line 166
                if (wave == 2) {
                    place_tree(0, 0, "fir");
                    trees_callback(game->trees, 0, 0, 30, tree_burn);
                }
            }
        }
    }
#line 170
    if (level.number == 3) {
        for (int wave = 0; wave < 10; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                if (wave < 4) {
#line 173
                    beetles(2, 400);
                }
#line 174
                else if (wave < 8) {
#line 174
                    beetles(3, 400);
                }
#line 175
                else if (wave == 8) {
#line 175
                    beetles(4, 400);
                }
#line 176
                else if (wave == 9) {
                    beetles(5, 400);
                    level.done = 1;
                }
            }
        }
    }
#line 180
    if (level.number == 4) {
        for (int wave = 0; wave < 14; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                if (wave % 2 == 0) {
                    beetles(1, 400);
                }
#line 184
                else {
#line 186
                    fires(1, 200);
                }
#line 187
                if (wave == 13) {
                    level.done = 1;
                }
            }
        }
    }
#line 190
    if (level.number == 5) {
        for (int wave = 0; wave < 1; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                level.done = 1;
            }
        }
    }
#line 195
    if (level.number == 6) {
        for (int wave = 0; wave < 10; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                if (wave < 4) {
#line 198
                    beetles(1, 400);
                }
#line 199
                else if (wave < 8) {
#line 199
                    beetles(2, 400);
                }
#line 200
                else if (wave < 9) {
#line 200
                    beetles(3, 400);
                }
#line 200
                else {
#line 202
                    beetles(4, 400);
                    level.done = 1;
                }
            }
        }
    }
#line 205
    if (level.number == 7) {
        for (int wave = 0; wave < 8; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                beetles(2, 400);
                if (wave == 7) {
                    level.done = 1;
                }
            }
        }
    }
#line 212
    if (level.number == 8) {
        for (int wave = 0; wave < 1; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                level.done = 1;
            }
        }
    }
#line 217
    if (level.number == 9) {
        for (int wave = 0; wave < 1; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                level.done = 1;
            }
        }
    }
#line 222
    if (level.number == 10) {
        for (int wave = 0; wave < 7; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                beetles(1 + wave, 450);
                if (wave == 6) {
                    level.done = 1;
                }
            }
        }
    }
#line 229
    if (level.number == 11) {
        for (int wave = 0; wave < 6; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                fires(1 + wave, 450);
                if (wave == 5) {
                    level.done = 1;
                }
            }
        }
    }
#line 236
    if (level.number == 12) {
        for (int wave = 0; wave < 20; wave += 1) {
            if (level.tick == 180 + 180 * wave) {
                if (wave % 4 == 0) {
                    beetles(2, 450);
                }
#line 241
                if (wave % 4 == 1) {
                    beetles(3, 450);
                }
#line 243
                if (wave % 4 == 2) {
                    fires(2, 400);
                }
#line 245
                if (wave % 4 == 3) {
                    fires(1, 400);
                    beetles(1, 400);
                    place_tree_rising(land_rnd(- 400, 400), land_rnd(- 400, 400), "eucalypt", 1);
                }
#line 249
                if (wave == 19) {
                    level.done = 1;
                }
            }
        }
    }
}
/* This file was generated by scramble.py. */
